
# Utility method to check if a process is running
# Parameters:
#    pid          : id of process
#    binary       : binary name which is running the process
#    waitAttempts : max wait time in seconds
# Returns:
#    0 :   if process id is running after given wait time
#    1 :   if process id is not running
isProcessRunning(){
  local pid="$1"
  local binary="$2"
  local waitAttempts=${3:-30}

  if [[ -z "${pid}" ]] || [[ -z "${binary}" ]]; then
      return 1
  fi
  for i in $(seq 1 $waitAttempts)
  do
      logger "Checking if process is alive (attempt #$i / $waitAttempts)..."

      if ps -ef | grep "${pid}" | grep ${binary} | grep -v grep > /dev/null
      then
          logger "Process $pid is still running"
      else
          logger "Process $pid is not running"
          return 1
      fi
      sleep 1
  done
  return 0
}

